:- object(maquina).

	:- public(aceita/2).
	
	aceita(Palavra , Desejo):-
		estadoInicial(InicialEstado),
		reconhece(Palavra, InicialEstado, Desejo).

	reconhece([], Estado, Desejo ):- 
		estadoFinal(Estado, Desejo ),!.
	
	reconhece([C|Resto], Estado, Desejo ):- 
		delta(Estado, C, ProximoEstado ),!,
		reconhece(Resto, ProximoEstado, Desejo ).

	estadoInicial(0).

	estadoFinal(Dinheiro, coffee):-
    	T is Dinheiro-50, T >= 0,
		T>0 -> darTroco(T),write('Yummy Coffee')
		; write('Yummy Coffee').

	estadoFinal(Dinheiro, chocolate):- 	
		T is Dinheiro-80, T >= 0,
		T>0 -> darTroco(T),write('Doce Chocolate')
		; write('Doce Chocolate').

	darTroco(T):-
		write('Troco = '),write(T),write(' Centimos'),nl.

	delta(IN,10,OUT):- OUT is IN+10.
	delta(IN,20,OUT):- OUT is IN+20.
	delta(IN,50,OUT):- OUT is IN+50.
	
	delta(IN,Moeda,_):-
		write('Moedas de '),write(Moeda),write(' Naosao  Aceites'),nl,
		Dinheiro is IN+Moeda,
		write('Fica com seu dinheiro '),write(Dinheiro),nl,!, fail.

:- end_object.